app.controller("commentsCtrl", function($scope, $stateParams, $ionicActionSheet, $ionicPopup, Comments, Settings) {
    $scope.refreshComments = function() {
        Comments.getComments($stateParams.ticketId, function(comments) {
            $scope.comments = comments;
        });
    }

    $scope.showActionSheet = function() {

        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({
            buttons: [
                { text: 'Set reply ' + ($scope.comment.techsOnly ? 'public' : 'for techs only') },
                { text: 'Canned responses' }
            ],
            cancelText: 'Cancel',
            buttonClicked: function(index) {
                if (index == 0)
                    $scope.comment.techsOnly = !$scope.comment.techsOnly;
                if (index == 1)
                    $scope.showCannedResponses();
                return true;
            }
        });

    };

    $scope.refreshComments();
    $scope.comment = {};
    var user = Settings.getUser();

    var parseTags = function(str) {
        if (str)
            return str.replace("#FirstName#", $scope.ticket.FirstName || "").replace("#LastName#", $scope.ticket.LastName || "");

        return "";
    }
    $scope.comment.body = parseTags(user.Greeting) + "\n\n\n" + parseTags(user.Signature);



    $scope.addComment = function() {
        Comments.addComment($scope.comment, $stateParams.ticketId, function() {
            $scope.refreshComments();
            $scope.comment = {};
        });
    };

    $scope.cannedResponses = Settings.getCannedResponses();


    var currentPopup = null;
    $scope.showCannedResponses = function() {
        currentPopup = $ionicPopup.show({
            templateUrl: 'templates/canned-responses.html',
            scope: $scope,
            title: "Canned responses",
            cssClass: "cannedPopup",
            buttons: [{
                text: 'Cancel'
            }]
        });
    }

    $scope.addCannedResponse = function(id) {
        var resp = $scope.cannedResponses.filter(function(obj) {
            return obj.TemplateId == id;
        })[0];

        $scope.comment.body += " " + resp.Body;

        currentPopup.close();
    }
});
