app.controller('MenuCtrl', function($scope, $rootScope, $ionicPopup, $ionicHistory, $ionicSideMenuDelegate, $cordovaCamera, Tickets) { //side menu in the tickets view

    $scope.hideMenu = function() {
        $ionicSideMenuDelegate.toggleRight(false); //WHY DON'T YOU HIDE AUTOMATICALLY???
    };

    $rootScope.$on('currentTicketChanged', function(event, args) { //update when the current viewed ticket changes
        $scope.ticket = Tickets.currentTicket();
        getStatuses();
    });


    $scope.changeStatus = function(statusId) {
        Tickets.setStatus($scope.ticket.TicketID, statusId).then(
            function() {
                getStatuses();
                $scope.hideMenu();
            });
    }

    var getStatuses = function() {
        Tickets.getStatuses($scope.ticket.TicketID, function(statuses) {
            $scope.statuses = statuses;
        });
    };

    $scope.deleteTicket = function() {
        var confirmPopup = $ionicPopup.confirm({
            title: 'Delete ticket',
            template: 'Are you sure you want to delete this ticket?'
        });
        confirmPopup.then(function(res) {
            if (res) {
                Tickets.deleteTicket($scope.ticket.TicketID).then(
                    function() {
                        $ionicHistory.goBack();
                        $scope.hideMenu();
                    });
            }
        });
    };

    $scope.spam = function() {
        var id = $scope.ticket.TicketID;
        var confirmPopup = $ionicPopup.confirm({
            title: 'Delete ticket',
            template: 'Are you sure you want to mark this ticket as spam?'
        });
        confirmPopup.then(function(res) {
            if (res) {
                Tickets.spamTicket(id).then(
                    function() {
                        $ionicHistory.goBack();
                        $scope.hideMenu();
                    });
            }
        });
    };

    $scope.uploadClicked = function() {
        // var options = {
        //         quality: 50,
        //         destinationType: navigator.camera.DestinationType.FILE_URI,
        //         sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY
        //     };
        $cordovaCamera.getPicture({sourceType: Camera.PictureSourceType.PHOTOLIBRARY}).then(
            function(imageURI) {
                //get mimetype and invoke "uploadFile" below
                window.resolveLocalFileSystemURL(imageURI,
                    function(fileEntry) {
                        fileEntry.file(function(filee) {
                            Tickets.uploadFile(imageURI, filee.type, $scope.ticket.TicketID);
                            $scope.hideMenu();
                        });
                    });
            },
            function(message) {
                alert('get file failed ' + message);
                $scope.hideMenu();
            }); 
    };
})
