app.controller('NewTicketCtrl', function($scope, $ionicHistory, $ionicPopup, $cordovaDatePicker, Tickets) {
    $scope.ticket = {};
    $scope.customFields = {};
    Tickets.getCategories(function(cats) {
        $scope.categories = cats;
    });
    $scope.createTicket = function(ticket) {
        //prepare custom fields
        if ($scope.customFields.length > 0) {
            var customFieldsStr = "{";
            angular.forEach($scope.customFields, function(field, index) {
                if (field.Value !== undefined)
                    customFieldsStr += field.FieldID + ':"' + field.Value + '",';
            });
            customFieldsStr += "}";
            ticket.customFields = customFieldsStr;
        }
        Tickets.createTicket(ticket).then(function() {
            $ionicHistory.goBack();
        }, function() {
            $ionicPopup.alert({
                title: 'Error',
                template: 'There was an error submitting your ticket. Try again. '
            });
        });
    };

    $scope.catChange = function() {
        var categoryId = $scope.ticket.categoryId || 0;
        Tickets.getCustomFieldsForCategory(categoryId, function(customFields) {
            $scope.customFields = customFields;
        });
    }

    $scope.getCustomFieldClassName = function(type) {
        switch (type) {
            case 2:
                return "datepicker";
            case 3: //dropdown
                return "item-select";

            case 4: //checkbox
                return "item-toggle";

            case 5:
                return "item-stacked-label"

            default: //all others do not need special treatment
                return "item-input";
        }
    }

    $scope.catChange(); //initital custom field load
});
