app.controller('TicketMetaCtrl', function($scope, $stateParams, $filter, $ionicPopup, $cordovaInAppBrowser, Tickets) {
    $scope.ticket = Tickets.currentTicket();
    $scope.customFields = [];
    if ($scope.ticket == null) {
        Tickets.getTicket($stateParams.ticketId, function(ticket) {
            $scope.ticket = ticket;
        });
    }

    Tickets.getCustomFields($stateParams.ticketId, function(fields) {
        $scope.customFields = fields;
    });

    var currentPopup = null;
    $scope.showPopup = function(mode) {
        if (mode == "category") {
            Tickets.getCategories(function(cats) {
                $scope.categories = cats;
            });
        } else if (mode == "assignee") {
            Tickets.getTechsForCategory($scope.ticket.CategoryID, function(techs) {
                $scope.techs = techs;
            });
        }

        var templateUrl = 'templates/meta/' + mode + '.html';

        currentPopup = $ionicPopup.show({
            templateUrl: templateUrl,
            scope: $scope,
            buttons: [{
                text: 'Cancel'
            }]
        });
    };

    $scope.setPriority = function(priority) {
        Tickets.setPriority($stateParams.ticketId, priority);
        $scope.ticket.Priority = priority;
        currentPopup.close();
    };

    $scope.changeCategory = function() {
        Tickets.setCategory($stateParams.ticketId, $scope.ticket.CategoryID);
        $scope.ticket.CategoryName = $filter('filter')($scope.categories, { CategoryID: $scope.ticket.CategoryID })[0].NameWithSection;
        currentPopup.close();
    };

    $scope.changeAssignee = function() {
        Tickets.setAssignee($stateParams.ticketId, $scope.ticket.AssignedToUserID);
        if(!$scope.ticket.AssigneeUserInfo)
            $scope.ticket.AssigneeUserInfo = {};
        
        $scope.ticket.AssigneeUserInfo.Username = $filter('filter')($scope.techs, { UserID: $scope.ticket.AssignedToUserID })[0].Username;
        currentPopup.close();
    };

    var options = {
        location: 'yes',
        clearcache: 'yes',
        toolbar: 'yes'
    };
    $scope.showAttachment = function(url) {
        $cordovaInAppBrowser.open(url, '_system', options)
    };

    $scope.openTicketInBrowser = function(url) {
        $cordovaInAppBrowser.open(url, '_system', options)
    }

    var getStatuses = function() {
        Tickets.getStatuses($stateParams.ticketId, function(statuses) {
            $scope.statuses = statuses;
        });
    };

    getStatuses();

    $scope.changeStatus = function(status) {
        console.log(status)
        Tickets.setStatus($stateParams.ticketId, status.StatusID).then(
            function() {
                $scope.ticket.Status = status.Name;
                getStatuses();
            });
    }
});
