var app = angular.module('hd.directives', []);
app.directive('ticketComments', function() {
    return {
        restrict: "E",
        templateUrl: "templates/ticket-comments.html",
        controller: "commentsCtrl"
    };
});

app.directive('newTicketComment', function() {
    // Runs during compile
    return {
        controller: "commentsCtrl",
        restrict: 'E',
        templateUrl: 'templates/ticket-comment-new.html',
        link: function($scope, iElm, iAttrs, controller) {

        }
    };
});

app.directive('sideMenu', function() {
    // Runs during compile
    return {
        controller: "MenuCtrl",
        restrict: 'E',
        templateUrl: 'templates/side-menu.html',
    };
});

app.directive('textarea', function() { //Textarea resizing to fit content. Works on all textareas automatically.
    return {
        restrict: 'E',
        link: function(scope, element, attr) {
            var update = function() {
                element.css("color", "#000"); //make text visible
                element.css("height", "auto");
                var height = element[0].scrollHeight;
                if (height == 36) height = height - 7; //when the textbox is empty, it doesnt resize properly. I don't know why. 
                element.css("height", height + "px");
            };

            element.bind("focus keydown", function(e) {
                    update();
                })
                // scope.$watch(attr.ngModel, function() {
                //   update();
                // });
        }
    };
});

app.directive('customField', function($compile) {

    var inputTemplate = '<input type="text" placeholder="{{field.FieldName}}" ng-model="field.Value"/>';
    var dateTemplate = '<input type="date" placeholder="{{field.FieldName}}" ng-model="field.Value"/>';
    var dropdownTemplate = '<select ng-model="field.Value" ng-options="option.OptionID as option.OptionValue for option in field.SelectionComboOptions"></select>';
    var checkboxTemplate = '<label class="toggle"> \
                                       <input type="checkbox" ng-model="field.Value"> \
                                       <div class="track"> \
                                         <div class="handle"></div> \
                                       </div> \
                                     </label>';
    var textareaTemplate = '<textarea placeholder="{{field.FieldName}}" ng-model="field.Value"/></textarea>';

    var getTemplate = function(field) {
        switch (field.Type) {
            case 2: //date
                return dateTemplate

            case 3: //dropdown
                return dropdownTemplate

            case 4: //checkbox
                return checkboxTemplate

            case 5: //textarea
                return textareaTemplate
            default: //all others do not need special treatment
                return inputTemplate
        }
    }

    var linker = function(scope, element, attrs) {
        element.html(getTemplate(scope.field));

        $compile(element.contents())(scope);
    }

    return {
        restrict: "E",
        link: linker,
        scope: {
            field: '='
        }
    };
});
