app.filter('toRelativeDate', function() {
    return function(date) {
        return moment(date).fromNow();
    }
});

app.filter('displayDate', function() {
    return function(date) {
        if (date == null) return "Not set";
        return moment(date).format('MMMM Do YYYY, hh:mm');
    }
});

app.filter('displayDuration', function() {
    return function(seconds) {
        if (seconds == null) {
            return "0h 0m"; }

        var duration = moment.duration(seconds, "second");

        return duration.hours() + "h " + duration.minutes() + "m";
    }
});

app.filter('displayPriority', function() {
    return function(priority) {
        switch (priority) {
            case -1:
                return "Low"

            case 0:
                return "Normal"

            case 1:
                return "High"

            case 2:
                return "Critical"

            default:
                return "Normal"
        }
    }
});

app.filter('displayField', function($sce) {
    return function(field) {
        if (!field.Value) return "Not set";

        switch (field.Type) {
            case 3: //dropdown
                return field.ValueWithOption

            case 4: //checkbox
                return $sce.trustAsHtml('<input type="checkbox" disabled="disabled" checked="' + (field.Value ? 'checked' : '') + '">')

            default: //all others do not need special treatment
                return field.Value
        }
    }
});

app.filter('hrefToJS', function ($sce, $sanitize) {
    return function (text) {
        var regex = /href="([\S]+)"/g;
        var newString = $sanitize(text).replace(regex, "onClick=\"window.open('$1', '_system')\"");
        return $sce.trustAsHtml(newString);
    }
});
